Main Page Namespace List Class Hierarchy Alphabetical List Compound List File List Namespace Members Compound Members File Members Related Pages

# ACE_Task_Ex<, ACE_MESSAGE_TYPE > Class Template Reference

Primary interface for application message processing, as well as input and output message queueing. More...

`#include <Task_Ex_T.h>`

Inheritance diagram for ACE_Task_Ex<, ACE_MESSAGE_TYPE >:

[legend]
Collaboration diagram for ACE_Task_Ex<, ACE_MESSAGE_TYPE >:

[legend]
List of all members.

## Public Types
typedef ACE_Message_Queue_Ex< ACE_MESSAGE_TYPE, ACE_SYNCH_USE > | MESSAGE_QUEUE_EX
## Public Methods
| ACE_Task_Ex (ACE_Thread_Manager *thr_mgr=0, MESSAGE_QUEUE_EX *mq=0)
virtual | ~ACE_Task_Ex (void)
| Destructor.
MESSAGE_QUEUE_EX * | msg_queue (void)
| Gets the message queue associated with this task.
void | msg_queue (MESSAGE_QUEUE_EX *)
| Sets the message queue associated with this task.
int | putq (ACE_MESSAGE_TYPE *, ACE_Time_Value *timeout=0)
int | getq (ACE_MESSAGE_TYPE *&mb, ACE_Time_Value *timeout=0)
int | ungetq (ACE_MESSAGE_TYPE *, ACE_Time_Value *timeout=0)
int | reply (ACE_MESSAGE_TYPE *, ACE_Time_Value *timeout=0)
int | put_next (ACE_MESSAGE_TYPE *msg, ACE_Time_Value *timeout=0)
int | can_put (ACE_MESSAGE_TYPE *)
| Tests whether we can enqueue a message without blocking.
const ACE_TCHAR * | name (void) const
ACE_Task< ACE_SYNCH_USE > * | next (void)
| Get next Task pointer.
void | next (ACE_Task< ACE_SYNCH_USE > *)
| Set next Task pointer.
ACE_Task< ACE_SYNCH_USE > * | sibling (void)
| Alwasy return 0.
ACE_Module< ACE_SYNCH_USE > * | module (void) const
| Return the Task's Module if there is one, else returns 0.
int | flush (u_long flag=ACE_Task_Flags::ACE_FLUSHALL)
void | water_marks (ACE_IO_Cntl_Msg::ACE_IO_Cntl_Cmds, size_t)
| Manipulate watermarks.
void | dump (void) const
| Dump the state of an object.
## Public Attributes
MESSAGE_QUEUE_EX * | msg_queue_
| Queue of messages on the ACE_Task..
int | delete_msg_queue_
| 1 if should delete Message_Queue, 0 otherwise.
ACE_Module< ACE_SYNCH_USE > * | mod_
| Back-pointer to the enclosing module.
ACE_Task< ACE_SYNCH_USE > * | next_
| Pointer to adjacent ACE_Task.
| ACE_ALLOC_HOOK_DECLARE
| Declare the dynamic allocation hooks.
## Private Methods
void | operator= (const ACE_Task_Ex< _ACE_SYNCH, ACE_MESSAGE_TYPE > &)
| ACE_Task_Ex (const ACE_Task_Ex< _ACE_SYNCH, ACE_MESSAGE_TYPE > &)
## Friends
class | ACE_Module< ACE_SYNCH_USE >
class | ACE_Module_Type

## Detailed Description

### template<ACE_SYNCH_DECL, class ACE_MESSAGE_TYPE>
class ACE_Task_Ex<, ACE_MESSAGE_TYPE >

Primary interface for application message processing, as well as input and output message queueing.

Unlike ACE_Task, these class doesn't have the ability to be a part of a Stream chain. I.e. You cannot (yet) chain modules based on ACE_Task_Ex.

Todo:
  : We can merge ACE_Task and ACE_Task_Ex to be one class. something like that: template <ACE_SYNCH_DECL, ACE_MESSAGE_TYPE = ACE_Message_Block> class ACE_Task : public ACE_Task_Base { // use here the code from ACE_Task_Ex using ACE_Message_Queue_Ex };

Now specialized version of ACE_Task with ACE_Message_Block as its ACE_MESSAGE_TYPE...

template <ACE_SYNCH_DECL> class ACE_Task <ACE_SYNCH_USE, ACE_Message_Block> : public ACE_Task_Base { // put here the good old ACE_Task code };

When User (and legacy code) write ACE_Task<ACE_MT_SYNCH>, specialized ACE_Task code is in action.

## Member Typedef Documentation

template<ACE_SYNCH_DECL , class ACE_MESSAGE_TYPE>
typedef ACE_Message_Queue_Ex<ACE_MESSAGE_TYPE, ACE_SYNCH_USE> ACE_Task_Ex<, ACE_MESSAGE_TYPE >::MESSAGE_QUEUE_EX

## Constructor & Destructor Documentation

template<ACE_SYNCH_DECL , class ACE_MESSAGE_TYPE>
ACE_Task_Ex<, ACE_MESSAGE_TYPE >::ACE_Task_Ex | ( | ACE_Thread_Manager * | thr_mgr = 0,
|  | MESSAGE_QUEUE_EX * | mq = 0
| ) |

| Initialize a Task, supplying a thread manager and a message queue. If the user doesn't supply a ACE_Message_Queue pointer then we'll allocate one dynamically. Otherwise, we'll use the one passed as a parameter.

template<ACE_SYNCH_DECL , class ACE_MESSAGE_TYPE>
ACE_Task_Ex<, ACE_MESSAGE_TYPE >::~ACE_Task_Ex | ( | void |  | ) | `[virtual]`

| Destructor.

template<ACE_SYNCH_DECL , class ACE_MESSAGE_TYPE>
ACE_Task_Ex<, ACE_MESSAGE_TYPE >::ACE_Task_Ex | ( | const ACE_Task_Ex< _ACE_SYNCH, ACE_MESSAGE_TYPE > & |  | ) | `[private]`

## Member Function Documentation

template<ACE_SYNCH_DECL , class ACE_MESSAGE_TYPE>
ACE_INLINE int ACE_Task_Ex<, ACE_MESSAGE_TYPE >::can_put | ( | ACE_MESSAGE_TYPE * |  | ) |

| Tests whether we can enqueue a message without blocking.

template<ACE_SYNCH_DECL , class ACE_MESSAGE_TYPE>
void ACE_Task_Ex<, ACE_MESSAGE_TYPE >::dump | ( | void |  | ) | const

| Dump the state of an object.

template<ACE_SYNCH_DECL , class ACE_MESSAGE_TYPE>
ACE_INLINE int ACE_Task_Ex<, ACE_MESSAGE_TYPE >::flush | ( | u_long | flag = ACE_Task_Flags::ACE_FLUSHALL | ) |

| Flush the task's queue, i.e., free all of the enqueued message blocks and releases any threads blocked on the queue. Note that if this conflicts with the C++ iostream <flush> function, just rewrite the iostream function as ::<flush>.

template<ACE_SYNCH_DECL , class ACE_MESSAGE_TYPE>
ACE_INLINE int ACE_Task_Ex<, ACE_MESSAGE_TYPE >::getq | ( | ACE_MESSAGE_TYPE *& | mb,
|  | ACE_Time_Value * | timeout = 0
| ) |

| Extract the first message from the queue (blocking). Note that <timeout> uses <{absolute}> time rather than <{relative}> time. Returns number of items in queue if the call succeeds or -1 otherwise.

template<ACE_SYNCH_DECL , class ACE_MESSAGE_TYPE>
ACE_Module< ACE_SYNCH_USE > * ACE_Task_Ex<, ACE_MESSAGE_TYPE >::module | ( | void |  | ) | const

| Return the Task's Module if there is one, else returns 0.

template<ACE_SYNCH_DECL , class ACE_MESSAGE_TYPE>
void ACE_Task_Ex<, ACE_MESSAGE_TYPE >::msg_queue | ( | MESSAGE_QUEUE_EX * |  | ) |

| Sets the message queue associated with this task.

template<ACE_SYNCH_DECL , class ACE_MESSAGE_TYPE>
ACE_Message_Queue_Ex< ACE_MESSAGE_TYPE, ACE_SYNCH_USE > * ACE_Task_Ex<, ACE_MESSAGE_TYPE >::msg_queue | ( | void |  | ) |

| Gets the message queue associated with this task.

template<ACE_SYNCH_DECL , class ACE_MESSAGE_TYPE>
const ACE_TCHAR * ACE_Task_Ex<, ACE_MESSAGE_TYPE >::name | ( | void |  | ) | const

| Return the name of the enclosing Module if there's one associated with the Task, else returns 0.

template<ACE_SYNCH_DECL , class ACE_MESSAGE_TYPE>
ACE_INLINE void ACE_Task_Ex<, ACE_MESSAGE_TYPE >::next | ( | ACE_Task< ACE_SYNCH_USE > * |  | ) |

| Set next Task pointer.

template<ACE_SYNCH_DECL , class ACE_MESSAGE_TYPE>
ACE_INLINE ACE_Task< ACE_SYNCH_USE > * ACE_Task_Ex<, ACE_MESSAGE_TYPE >::next | ( | void |  | ) |

| Get next Task pointer.

template<ACE_SYNCH_DECL , class ACE_MESSAGE_TYPE>
void ACE_Task_Ex<, ACE_MESSAGE_TYPE >::operator= | ( | const ACE_Task_Ex< _ACE_SYNCH, ACE_MESSAGE_TYPE > & |  | ) | `[private]`

template<ACE_SYNCH_DECL , class ACE_MESSAGE_TYPE>
ACE_INLINE int ACE_Task_Ex<, ACE_MESSAGE_TYPE >::put_next | ( | ACE_MESSAGE_TYPE * | msg,
|  | ACE_Time_Value * | timeout = 0
| ) |

| Transfer message to the adjacent ACE_Task_Ex in a ACE_Stream. Note that <timeout> uses <{absolute}> time rather than <{relative}> time.

template<ACE_SYNCH_DECL , class ACE_MESSAGE_TYPE>
ACE_INLINE int ACE_Task_Ex<, ACE_MESSAGE_TYPE >::putq | ( | ACE_MESSAGE_TYPE * | ,
|  | ACE_Time_Value * | timeout = 0
| ) |

| Insert message into the message queue. Note that <timeout> uses <{absolute}> time rather than <{relative}> time.

template<ACE_SYNCH_DECL , class ACE_MESSAGE_TYPE>
ACE_INLINE int ACE_Task_Ex<, ACE_MESSAGE_TYPE >::reply | ( | ACE_MESSAGE_TYPE * | ,
|  | ACE_Time_Value * | timeout = 0
| ) |

| Turn the message around and send it back down the Stream. Note that <timeout> uses <{absolute}> time rather than <{relative}> time.

template<ACE_SYNCH_DECL , class ACE_MESSAGE_TYPE>
ACE_Task< ACE_SYNCH_USE > * ACE_Task_Ex<, ACE_MESSAGE_TYPE >::sibling | ( | void |  | ) |

| Alwasy return 0. Todo: FIXME

template<ACE_SYNCH_DECL , class ACE_MESSAGE_TYPE>
ACE_INLINE int ACE_Task_Ex<, ACE_MESSAGE_TYPE >::ungetq | ( | ACE_MESSAGE_TYPE * | ,
|  | ACE_Time_Value * | timeout = 0
| ) |

| Return a message to the queue. Note that <timeout> uses <{absolute}> time rather than <{relative}> time.

template<ACE_SYNCH_DECL , class ACE_MESSAGE_TYPE>
ACE_INLINE void ACE_Task_Ex<, ACE_MESSAGE_TYPE >::water_marks | ( | ACE_IO_Cntl_Msg::ACE_IO_Cntl_Cmds | ,
|  | size_t |
| ) |

| Manipulate watermarks.

## Friends And Related Function Documentation

template<ACE_SYNCH_DECL , class ACE_MESSAGE_TYPE>
friend class ACE_Module< ACE_SYNCH_USE >`[friend]`

template<ACE_SYNCH_DECL , class ACE_MESSAGE_TYPE>
friend class ACE_Module_Type`[friend]`

## Member Data Documentation

template<ACE_SYNCH_DECL , class ACE_MESSAGE_TYPE>
ACE_Task_Ex<, ACE_MESSAGE_TYPE >::ACE_ALLOC_HOOK_DECLARE

| Declare the dynamic allocation hooks.

template<ACE_SYNCH_DECL , class ACE_MESSAGE_TYPE>
int ACE_Task_Ex<, ACE_MESSAGE_TYPE >::delete_msg_queue_

| 1 if should delete Message_Queue, 0 otherwise.

template<ACE_SYNCH_DECL , class ACE_MESSAGE_TYPE>
ACE_Module<ACE_SYNCH_USE>* ACE_Task_Ex<, ACE_MESSAGE_TYPE >::mod_

| Back-pointer to the enclosing module.

template<ACE_SYNCH_DECL , class ACE_MESSAGE_TYPE>
MESSAGE_QUEUE_EX* ACE_Task_Ex<, ACE_MESSAGE_TYPE >::msg_queue_

| Queue of messages on the ACE_Task..

template<ACE_SYNCH_DECL , class ACE_MESSAGE_TYPE>
ACE_Task<ACE_SYNCH_USE>* ACE_Task_Ex<, ACE_MESSAGE_TYPE >::next_

| Pointer to adjacent ACE_Task.

The documentation for this class was generated from the following files:

- /export2/deucetmp/bala/release_try/ACE_wrappers/ace/Task_Ex_T.h
- /export2/deucetmp/bala/release_try/ACE_wrappers/ace/Task_Ex_T.cpp
- /export2/deucetmp/bala/release_try/ACE_wrappers/ace/Task_Ex_T.i